DROP TABLE IF EXISTS textblocks;
DROP TABLE IF EXISTS pages;
CREATE TABLE pages (
  `uri` VARCHAR(255) NOT NULL,
  `identifier` INT NOT NULL AUTO_INCREMENT,
  `title` VARCHAR(255),
  `name` VARCHAR(255) NOT NULL,
  `parent_page` VARCHAR(255),
  `columns` INT(11),
  UNIQUE(`identifier`),
  UNIQUE(`name`),
  PRIMARY KEY(`uri`)
)TYPE=InnoDb;

CREATE TABLE textblocks (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `key` VARCHAR(255) NOT NULL,
  `title` VARCHAR(255),
  `data` TEXT NOT NULL,
  `image` VARCHAR(255),
  `column` INT(11),
  `position` INT(11),
  `page_ref` VARCHAR(255) NOT NULL,
  PRIMARY KEY(`id`),
  UNIQUE(`key`, `page_ref`),
  UNIQUE(`page_ref`, `column`, `position`),
  FOREIGN KEY (`page_ref`) REFERENCES pages(`uri`) ON DELETE CASCADE
)TYPE=InnoDb;

DROP TABLE IF EXISTS users;
CREATE TABLE users (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(255) NOT NULL,
  `email` VARCHAR(255) NOT NULL,
  `password` VARCHAR(255) NOT NULL,
  UNIQUE(`email`),
  PRIMARY KEY(`id`)
)TYPE=InnoDb;
INSERT INTO users (`name`, `email`, `password`) VALUES (
"Max", "admin@admin.com", MD5("pass")
);
DROP TABLE IF EXISTS errors;
CREATE TABLE errors (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `message` TEXT NOT NULL,
  `timestamp` TIMESTAMP NOT NULL,
  PRIMARY KEY(`id`)
)TYPE=InnoDb;
DROP TABLE IF EXISTS files;
CREATE TABLE files (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `uri` VARCHAR(255) NOT NULL,
  `filename` VARCHAR(255) NOT NULL,
  `added`  BIGINT(20) NOT NULL,
  `edited` BIGINT(20) NOT NULL,
  `filesize` INT(11) NOT NULL,
  `data` LONGBLOB NOT NULL,
  `content-type` VARCHAR(255) NOT NULL,
  `height` INT(11),
  `width` INT(11),
  UNIQUE(`uri`),
  PRIMARY KEY(`id`)
)TYPE=InnoDb;

DROP TABLE IF EXISTS news_items;
CREATE TABLE news_items(
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `text` TEXT NOT NULL,
  `timestamp` TIMESTAMP NOT NULL,
  `headline` TEXT NOT NULL,
  PRIMARY KEY(`id`)
)TYPE=InnoDb;