/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.plc.graphic.classes;

import java.awt.Toolkit;
import java.io.IOException;
import java.sql.SQLException;
import java.util.Collections;
import java.util.Date;
import java.util.Vector;

/**
 *
 * @author Max
 */
public class UploadedImage extends UploadedFile {

    private int width;
    private int height;

    public UploadedImage(int id, String uri, String filename, String contentType,
            long filesize, Date added, Date edited, int width, int height) {
        super(id, uri, filename, contentType, filesize, added, edited);
        this.width = width;
        this.height = height;
    }

    public static UploadedImage getImage(int id) throws SQLException{
        return UploadedImage.getFile(id);
    }

    public static UploadedImage getImageByURI(String uri) throws SQLException {
        return UploadedImage.getFileByURI(uri);
    }

    public static UploadedImage getFile(int id) throws SQLException{
        return (UploadedImage) UploadedFile.getFile(id);
    }

    public static UploadedImage getFileByURI(String uri)  throws SQLException{
        return (UploadedImage) UploadedFile.getFileByURI(uri);
    }
    public static UploadedImage[] getImages()  throws SQLException{
        UploadedFile[] files = UploadedFile.getFiles();
        Vector<UploadedImage> images = new Vector<UploadedImage>();
        for(UploadedFile file : files)if(file.isImage()) images.add((UploadedImage)file);
        return images.toArray(new UploadedImage[images.size()]);
    }
    /**
     * @return the width
     */
    public int getWidth() {
        return width;
    }

    /**
     * @return the height
     */
    public int getHeight() {
        return height;
    }

    public static String[] getUploadedImagesForSlideshow() throws SQLException{
        UploadedImage[] images = getImages();
        Vector<String> slideShowSrc = new Vector<String>();
        for(UploadedImage img : images){
            if(img.getUri().matches("^/slideshow/.*$")){
                slideShowSrc.add("/uploads"+img.getUri());
            }
        }
        Collections.sort(slideShowSrc);
        return slideShowSrc.toArray(new String[slideShowSrc.size()]);
    }

    public java.awt.Image getImage() throws IOException, SQLException {
        return getImageFromData(getBytes());
    }

    public static java.awt.Image getImageFromData(byte[] data) {
        return Toolkit.getDefaultToolkit().createImage(data);
    }

    public static boolean isContentTypeImage(String contentType) {
        return (contentType.matches("^image/.*$"));
    }
}
