/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package uk.plc.graphic.database;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;



/**
 *
 * @author Max
 */
public class DatabaseConnection {
//    private static final String username="graphic";
//    private static final String password="graphic";
//    private static final String database="graphic";
//    private static final String server="localhost";
//
//    private static Connection connection;
    private static DataSource dataSource;

    public static Connection getConnection() throws SQLException{
//        if (connection == null || connection.isClosed()) {
//            setupConnection();
//        }
//        return connection;
        try {
            if (dataSource == null) {
                initialise();
            }
            return dataSource.getConnection();
        } catch (NamingException namingException) {
            throw new SQLException(namingException);
        }
    }
    public static void closeConnection(Connection connection){
        if(connection!=null){
            try {
                if (!connection.isClosed()) {
                    connection.close();
                    connection = null;
                }
            } catch (SQLException ex) {
                //Should not happen
            }
        }
    }
    public static void closePreparedStatement(PreparedStatement statement){
        if(statement!=null){
            try {
                statement.close();
                statement = null;
            } catch (SQLException ex) {
                //Should not happen
            } catch(RuntimeException ex){
            } catch(Exception ex){

            }
        }
    }
    public static void closeResultSet(ResultSet resultSet){
        if(resultSet!=null){
            try {
                resultSet.close();
                resultSet = null;
            } catch (SQLException ex) {
                //Should not happen
            }catch(RuntimeException ex){
            }catch(Exception ex){

            }
        }
    }
    public static int getLastInsertIdInt(Connection connection) throws SQLException{
        return Integer.parseInt(getLastInsertId(connection));
    }
    public static String getLastInsertId(Connection conn) throws SQLException{
        PreparedStatement preparedStatement = null;
        ResultSet resultSet = null;
        try{
            preparedStatement = conn.prepareStatement("SELECT LAST_INSERT_ID() AS `last_id`");
            resultSet = preparedStatement.executeQuery();

            String id = "";
            if(resultSet.next()){
                id = resultSet.getString("last_id");
            }
            return id;
        }finally{
            closeResultSet(resultSet);
            closePreparedStatement(preparedStatement);
        }
    }
    private static void initialise() throws NamingException{
        InitialContext ctx = new InitialContext();
        dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/graphic_db");
    }
//    private static Connection setupConnection() throws SQLException{
//        try {
//            String url = "jdbc:mysql://" + server + "/" + database;
//            Class.forName("com.mysql.jdbc.Driver").newInstance();
//            return DriverManager.getConnection(url, username, password);
//        } catch (ClassNotFoundException ex) {
//            throw new SQLException(ex);
//        }catch (InstantiationException ex) {
//            throw new SQLException(ex);
//        } catch (IllegalAccessException ex) {
//            throw new SQLException(ex);
//        }
//    }
    public static String testConnection(){
        String ret;
        Connection conn = null;
        try {
            conn = DatabaseConnection.getConnection();
            ret = "Successfully Connected";
        } catch (SQLException ex) {
            ret = "Failed to Connect: "+ex.getMessage();
        }finally{
            DatabaseConnection.closeConnection(conn);
        }
        return ret;
    }

}
