/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.plc.graphic.filters;

import java.io.IOException;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import uk.plc.graphic.classes.Page;

/**
 *
 * @author Max
 */
public class GetPage implements Filter {

  private static final boolean debug = true;
  // The filter configuration object we are associated with.  If
  // this value is null, this filter instance is not currently
  // configured.
  private FilterConfig filterConfig = null;

  public GetPage() {
  }

  /**
   *
   * @param request The servlet request we are processing
   * @param response The servlet response we are creating
   * @param chain The filter chain we are processing
   *
   * @exception IOException if an input/output error occurs
   * @exception ServletException if a servlet error occurs
   */
  public void doFilter(ServletRequest request, ServletResponse response,
          FilterChain chain)
          throws IOException, ServletException {
    String pageUri = "";
    if (request instanceof HttpServletRequest) {
      HttpServletRequest httpRequest = (HttpServletRequest) request;
      pageUri = httpRequest.getRequestURI();
      if (!pageUri.matches("^/admin/.*$") && !pageUri.matches("^/assets/.*$") && !pageUri.matches("^/news.jsp$")
              && (pageUri.matches("^.*\\.jsp$") || (pageUri.matches("^.*/$")))) {
        if (pageUri.endsWith("/")) {
          pageUri += "index.jsp";
        }
        try {
          Page thispage = Page.getPage(pageUri);
          Calendar lastUpdated = thispage.getLastUpdated();
          if (thispage != null) {
            thispage.getTextBlocks();
          } else {
            ((HttpServletResponse) response).sendError(HttpServletResponse.SC_NOT_FOUND);
            return;
          }
          request.setAttribute("current_page", thispage);
          request.setAttribute("last_updated", lastUpdated);
          request.setAttribute("last_updated_str", prettyDate(lastUpdated));
        } catch (SQLException sQLException) {
          ((HttpServletResponse) response).sendError(HttpServletResponse.SC_NOT_FOUND);
          return;
        }
      }
    }
//        if(pageUri.endsWith("tiny_mce_gzip.jsp")){
//           ((HttpServletResponse)response).
//        }
    chain.doFilter(request, response);

  }
  public String prettyDate(Calendar date){
      //hh:mm:ss 
      SimpleDateFormat formatter = new SimpleDateFormat("dd MMM yyyy");
      return formatter.format(date.getTime());
  }
  /**
   * Return the filter configuration object for this filter.
   */
  public FilterConfig getFilterConfig() {
    return (this.filterConfig);
  }

  /**
   * Set the filter configuration object for this filter.
   *
   * @param filterConfig The filter configuration object
   */
  public void setFilterConfig(FilterConfig filterConfig) {
    this.filterConfig = filterConfig;
  }

  /**
   * Destroy method for this filter
   */
  public void destroy() {
  }

  /**
   * Init method for this filter
   */
  public void init(FilterConfig filterConfig) {
    this.filterConfig = filterConfig;
    if (filterConfig != null) {
      if (debug) {
        log("GetPage:Initializing filter");
      }
    }
  }

  /**
   * Return a String representation of this object.
   */
  @Override
  public String toString() {
    if (filterConfig == null) {
      return ("GetPage()");
    }
    StringBuffer sb = new StringBuffer("GetPage(");
    sb.append(filterConfig);
    sb.append(")");
    return (sb.toString());
  }

  public void log(String msg) {
    filterConfig.getServletContext().log(msg);
  }
}
