/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package uk.plc.graphic.filters;

import java.io.IOException;
import java.net.URLEncoder;
import java.sql.SQLException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import uk.plc.graphic.classes.Page;
import uk.plc.graphic.classes.UploadedFile;
import uk.plc.graphic.classes.UploadedImage;

/**
 *
 * @author Max
 */
public class GetPageByIdentifier implements Filter {

    private static final boolean debug = true;

    // The filter configuration object we are associated with.  If
    // this value is null, this filter instance is not currently
    // configured. 
    private FilterConfig filterConfig = null;

    public GetPageByIdentifier() {
    } 

 

    /**
     *
     * @param request The servlet request we are processing
     * @param response The servlet response we are creating
     * @param chain The filter chain we are processing
     *
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet error occurs
     */
    public void doFilter(ServletRequest request, ServletResponse response,
                         FilterChain chain)
	throws IOException, ServletException {
        boolean gotPage = false;
	if(request instanceof HttpServletRequest){
            if(request.getParameter("p")!=null){
                try {
                    int identifier = Integer.parseInt(request.getParameter("p"));
                    Page pageToEdit = Page.getPageByIdentifier(identifier);
                    UploadedImage[] images = UploadedImage.getImages();
                    UploadedFile[] files = UploadedFile.getFiles();
                    Page[] pages = Page.getPages();
                    request.setAttribute("images", images);
                    request.setAttribute("files", files);
                    request.setAttribute("pages", pages);
                    
                    if(pageToEdit!=null){
                        pageToEdit.getTextBlocks();
                        request.setAttribute("page_to_edit", pageToEdit);
                        gotPage = true;
                    }else{
                        request.setAttribute("error", "Page with id "+identifier+" not found");
                    }
                } catch (SQLException ex) {
                    request.setAttribute("error", "SQL Error: '"+ex.getMessage()+"'");
                } catch (NumberFormatException numberFormatException) {
                    request.setAttribute("error", "Page id given is not a valid number");
                }
            }
            
        }
        if(gotPage){
            chain.doFilter(request, response);
            return;
        }else{
            if(response instanceof HttpServletResponse){
                ((HttpServletResponse)response).sendRedirect("/admin/page-listing.jsp?err="+
                        URLEncoder.encode((String)request.getAttribute("error"), "UTF-8"));
                return;
//                try {
//                    HttpServletRequest httpRequest = (HttpServletRequest) request;
//                    HttpSession session = httpRequest.getSession(false);
//                    request.setAttribute("current_user", User.getUser((Integer) session.getAttribute("userid")));
//                    filterConfig.getServletContext().getRequestDispatcher("/admin/page-listing.jsp").forward(request, response);
//                    return;
//                } catch (SQLException ex) {
//                }
            }
        }
        chain.doFilter(request, response);
    }
    
    /**
     * Return the filter configuration object for this filter.
     */
    public FilterConfig getFilterConfig() {
	return (this.filterConfig);
    }

    /**
     * Set the filter configuration object for this filter.
     *
     * @param filterConfig The filter configuration object
     */
    public void setFilterConfig(FilterConfig filterConfig) {
	this.filterConfig = filterConfig;
    }

    /**
     * Destroy method for this filter 
     */
    public void destroy() { 
    }

    /**
     * Init method for this filter 
     */
    public void init(FilterConfig filterConfig) { 
	this.filterConfig = filterConfig;
	if (filterConfig != null) {
	    if (debug) { 
		log("GetPageByIdentifier:Initializing filter");
	    }
	}
    }

    /**
     * Return a String representation of this object.
     */
    @Override
    public String toString() {
	if (filterConfig == null) return ("GetPageByIdentifier()");
	StringBuffer sb = new StringBuffer("GetPageByIdentifier(");
	sb.append(filterConfig);
	sb.append(")");
	return (sb.toString());
    }

   

    public void log(String msg) {
	filterConfig.getServletContext().log(msg); 
    }

}
