/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package uk.plc.graphic.filters;

import java.io.IOException;
import java.sql.SQLException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import uk.plc.graphic.classes.FileFolder;
import uk.plc.graphic.classes.Page;
import uk.plc.graphic.classes.PageFolder;

/**
 *
 * @author Max
 */
public class GetPages implements Filter {

    private static final boolean debug = true;

    // The filter configuration object we are associated with.  If
    // this value is null, this filter instance is not currently
    // configured. 
    private FilterConfig filterConfig = null;

    public GetPages() {
    } 

    /**
     *
     * @param request The servlet request we are processing
     * @param response The servlet response we are creating
     * @param chain The filter chain we are processing
     *
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet error occurs
     */
    public void doFilter(ServletRequest request, ServletResponse response,
                         FilterChain chain)
	throws IOException, ServletException {
        try {
            if(request.getParameter("err")!=null){
                request.setAttribute("error", request.getParameter("err"));
            }
//            request.setAttribute("page_listing", Page.getPages());
            StringBuffer listing = new StringBuffer();
     
            PageFolder pages = Page.getSortedPages();
            listing.append(getFolderListing(pages));
  
            request.setAttribute("page_listing", listing.toString());
        } catch (SQLException ex) {
            request.setAttribute("error", "SQL Error "+ex.getMessage());
        }
        chain.doFilter(request, response);
    }
    
    public static String getFolderListing(PageFolder folder){
        StringBuffer buffer = new StringBuffer("<ul class=\"folderlisting\">");
        PageFolder[] subFolders = folder.getFolders();
        for(PageFolder subFolder : subFolders){
            buffer.append("<li class=\"folder\">");
            buffer.append(subFolder.getName());
            buffer.append("</li>");
            buffer.append(getFolderListing(subFolder));
        }
        Page[] pages = folder.getFiles();
        for(Page page : pages){
            buffer.append("<li class=\"page\">");
            
            buffer.append("<table cellpadding=\"0\" cellpadding=\"0\" style=\"display:inline;\">");
            buffer.append("<tr>");
            buffer.append("<td>");
            buffer.append(page.getName());
            buffer.append("</td>");
            buffer.append("<td>");
            buffer.append("<a href=\""+page.getUri()+"\" target=\"_blank\" class=\"view\" title=\"View\">&nbsp;<!--view--></a>");
            buffer.append("</td>");
            buffer.append("<td>");
            buffer.append("<a href=\"/admin/edit-page.jsp?p="+page.getIdentifier()+"\" class=\"edit\" title=\"Edit\">&nbsp;<!--edit--></a>");
            buffer.append("</td>");
            buffer.append("</tr>");
            buffer.append("</table>");
            buffer.append("</li>");
        }
        buffer.append("</ul>");
        return buffer.toString();
    }
    /**
     * Return the filter configuration object for this filter.
     */
    public FilterConfig getFilterConfig() {
	return (this.filterConfig);
    }

    /**
     * Set the filter configuration object for this filter.
     *
     * @param filterConfig The filter configuration object
     */
    public void setFilterConfig(FilterConfig filterConfig) {
	this.filterConfig = filterConfig;
    }

    /**
     * Destroy method for this filter 
     */
    public void destroy() { 
    }

    /**
     * Init method for this filter 
     */
    public void init(FilterConfig filterConfig) { 
	this.filterConfig = filterConfig;
	if (filterConfig != null) {
	    if (debug) { 
		log("GetPages:Initializing filter");
	    }
	}
    }

    /**
     * Return a String representation of this object.
     */
    @Override
    public String toString() {
	if (filterConfig == null) return ("GetPages()");
	StringBuffer sb = new StringBuffer("GetPages(");
	sb.append(filterConfig);
	sb.append(")");
	return (sb.toString());
    }


    public void log(String msg) {
	filterConfig.getServletContext().log(msg); 
    }

}
