/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package uk.plc.graphic.filters.admin;

import java.io.IOException;
import java.net.URLDecoder;
import java.sql.SQLException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import uk.plc.graphic.classes.FileFolder;
import uk.plc.graphic.classes.Folder;
import uk.plc.graphic.classes.UploadedFile;

/**
 *
 * @author Max
 */
public class GetFiles implements Filter {

    private static final boolean debug = true;

    // The filter configuration object we are associated with.  If
    // this value is null, this filter instance is not currently
    // configured. 
    private FilterConfig filterConfig = null;

    public GetFiles() {
    } 

    

    /**
     *
     * @param request The servlet request we are processing
     * @param response The servlet response we are creating
     * @param chain The filter chain we are processing
     *
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet error occurs
     */
    public void doFilter(ServletRequest request, ServletResponse response,
                         FilterChain chain)
	throws IOException, ServletException {
        String error = request.getParameter("err");
        StringBuffer listing = new StringBuffer();
        listing.append("<div class=\"ajax_wrapper\">");
        if(error!=null){
            listing.append("<div class=\"error\">");
            listing.append(URLDecoder.decode(error, "UTF-8"));
            listing.append("</div>");
        }
        try {
            FileFolder files = UploadedFile.getSortedFiles();
            FileFolder[] allFolders = files.getAllFolders();
            listing.append(getFolderListing(files, allFolders));
            request.setAttribute("files", files);
        } catch (SQLException sQLException) {
            listing.append("<div class=\"error\">");
            listing.append(sQLException.getMessage());
            listing.append("</div>");
        }
        listing.append("</div>");
	request.setAttribute("file_listing", listing.toString());
        chain.doFilter(request, response);
        return;
    }
    public static String getFolderListing(FileFolder folder, Folder[] allFolders){
        StringBuffer buffer = new StringBuffer("<ul class=\"folderlisting\">");
        FileFolder[] subFolders = folder.getFolders();
        for(FileFolder subFolder : subFolders){
            buffer.append("<li class=\"folder\">");
            //buffer.append("<span class=\"foldername\">");
            buffer.append(subFolder.getName());
            //buffer.append("</span>");
            buffer.append("</li>");
            buffer.append(getFolderListing(subFolder, allFolders));
        }
        UploadedFile[] files = folder.getFiles();
        String folderUri = folder.getFullUri();

        String allFolderUri;
        for(UploadedFile file : files){
            if(file.isImage()){
                buffer.append("<li class=\"image\">");
            }else{
                buffer.append("<li class=\"file\">");
            }
            buffer.append("<table cellpadding=\"0\" cellpadding=\"0\" style=\"display:inline;\">");
            buffer.append("<tr>");
            buffer.append("<td style=\"width:150px;overflow:hidden;\">");
            buffer.append(file.getFilename());
            buffer.append("</td>");
            buffer.append("<td>");
            buffer.append("<a href=\"/uploads"+file.getUri()+"\" target=\"_blank\" class=\"view\" title=\"View\"><!--view--></a>");
            buffer.append("</td>");
            buffer.append("<td>");
            buffer.append("<a href=\"javascript:deleteFile("+file.getId()+", '"+file.getFilename()+"');\" class=\"delete\" title=\"Delete\"><!--delete--></a>");
            buffer.append("</td>");
            buffer.append("<td>");
            buffer.append("<form name=\"form_move_"+file.getId()+"\" id=\"form_move_"+file.getId()+"\" class=\"move_form\">");
            buffer.append("<select name=\"folder_selection\">");
            for(Folder f : allFolders){
                allFolderUri = f.getFullUri();
                buffer.append("<option value=\"");
                buffer.append(allFolderUri);
                buffer.append("\" ");
                if(allFolderUri.equals(folderUri))
                    buffer.append("selected=\"selected\" ");
                buffer.append(">");
                buffer.append(allFolderUri);
                buffer.append("</option>");
            }
            buffer.append("</select>");
            buffer.append("<input name=\"new_folder\" value=\"\" type=\"text\"/>");
            buffer.append("<a class=\"button small_button\" href=\"javascript:move("+file.getId()+");\" title=\"Move\">Move</a>");
            buffer.append("</form>");
            buffer.append("</td>");
            buffer.append("</tr>");
            buffer.append("</table>");
            buffer.append("</li>");
        }
        buffer.append("</ul>");
        return buffer.toString();
    }
//    public static String getFolderListing(Folder folder, Folder[] allFolders){
//        StringBuffer buffer = new StringBuffer("<ul class=\"folderlisting\">");
//        Folder[] subFolders = folder.getFolders();
//        for(UploadedFile.Folder subFolder : subFolders){
//            buffer.append("<li class=\"folder\">");
//            //buffer.append("<span class=\"foldername\">");
//            buffer.append(subFolder.getName());
//            //buffer.append("</span>");
//            buffer.append("</li>");
//            buffer.append(getFolderListing(subFolder, allFolders));
//        }
//        UploadedFile[] files = folder.getFiles();
//        String folderUri = folder.getFullUri();
//
//        String allFolderUri;
//        for(UploadedFile file : files){
//            if(file.isImage()){
//                buffer.append("<li class=\"image\">");
//            }else{
//                buffer.append("<li class=\"file\">");
//            }
//            buffer.append(file.getFilename());
//            buffer.append("&nbsp;&nbsp;<a href=\"/uploads"+file.getUri()+"\" target=\"_blank\" class=\"view\" title=\"View\"><!--view--></a>");
//            buffer.append("<form name=\"form_delete_"+file.getId()+"\" id=\"form_delete_"+file.getId()+"\" class=\"delete_form\">");
//            buffer.append("<a href=\"javascript:delete("+file.getId()+");\" class=\"delete\" title=\"Delete\"><!--delete--></a>");
//            buffer.append("</form>");
//            buffer.append("<form name=\"form_move_"+file.getId()+"\" id=\"form_move_"+file.getId()+"\" class=\"move_form\">");
//            buffer.append("<select name=\"folder_selection\">");
//            for(Folder f : allFolders){
//                allFolderUri = f.getFullUri();
//                buffer.append("<option value=\"");
//                buffer.append(allFolderUri);
//                buffer.append("\" ");
//                if(allFolderUri.equals(folderUri))
//                    buffer.append("selected=\"selected\" ");
//                buffer.append(">");
//                buffer.append(allFolderUri);
//                buffer.append("</option>");
//            }
//            buffer.append("</select>");
//            buffer.append("<input name=\"new_folder\" value=\"\" type=\"text\"/>");
//            buffer.append("<a class=\"button small_button\" href=\"javascript:move("+file.getId()+");\" title=\"Move\">Move</a>");
//            buffer.append("</form>");
//            buffer.append("</li>");
//        }
//        buffer.append("</ul>");
//        return buffer.toString();
//    }
    /**
     * Return the filter configuration object for this filter.
     */
    public FilterConfig getFilterConfig() {
	return (this.filterConfig);
    }

    /**
     * Set the filter configuration object for this filter.
     *
     * @param filterConfig The filter configuration object
     */
    public void setFilterConfig(FilterConfig filterConfig) {
	this.filterConfig = filterConfig;
    }

    /**
     * Destroy method for this filter 
     */
    public void destroy() { 
    }

    /**
     * Init method for this filter 
     */
    public void init(FilterConfig filterConfig) { 
	this.filterConfig = filterConfig;
	if (filterConfig != null) {
	    if (debug) { 
		log("GetFiles:Initializing filter");
	    }
	}
    }

    /**
     * Return a String representation of this object.
     */
    @Override
    public String toString() {
	if (filterConfig == null) return ("GetFiles()");
	StringBuffer sb = new StringBuffer("GetFiles(");
	sb.append(filterConfig);
	sb.append(")");
	return (sb.toString());
    }


    public void log(String msg) {
	filterConfig.getServletContext().log(msg); 
    }

}
