/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.plc.graphic.servlets.admin;

import java.io.IOException;
import java.net.URLEncoder;
import java.sql.SQLException;
import java.sql.Timestamp;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import uk.plc.graphic.classes.NewsItem;

/**
 *
 * @author David Walker
 */
public class EditNewsItem extends HttpServlet {

  /**
   * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
   * @param request servlet request
   * @param response servlet response
   * @throws ServletException if a servlet-specific error occurs
   * @throws IOException if an I/O error occurs
   */
  protected void processRequest(HttpServletRequest request, HttpServletResponse response)
          throws ServletException, IOException {
    String error = null;
    String newsItemId = request.getParameter("news_item_id");
    String headline = request.getParameter("headline");
    String newsText = request.getParameter("textarea_edit_news_text");

    NewsItem newsItem = null;
    if (newsItemId == null) {
      // We are saving a new news item.
      try {
        newsItem = NewsItem.insertNewsItem(newsText, headline);
      } catch (SQLException ex) {
        error = "SQL Exception: '" + ex.getMessage() + "'";
      } catch (NumberFormatException ex) {
        error = "Page id given is not a valid number";
      }
    } else {
      newsItem = new NewsItem(Integer.parseInt(newsItemId), newsText, new Timestamp(System.currentTimeMillis()), headline);
      try {
        newsItem.editNewsItem();
      } catch (SQLException ex) {
        error = "SQL Exception: '" + ex.getMessage() + "'";
      }
    }
    response.sendRedirect("/admin/news-listing.jsp"
            + (error != null ? "?err=" + URLEncoder.encode(error, "UTF-8") : ""));
  }

  // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
  /**
   * Handles the HTTP <code>GET</code> method.
   * @param request servlet request
   * @param response servlet response
   * @throws ServletException if a servlet-specific error occurs
   * @throws IOException if an I/O error occurs
   */
  @Override
  protected void doGet(HttpServletRequest request, HttpServletResponse response)
          throws ServletException, IOException {
    processRequest(request, response);
  }

  /**
   * Handles the HTTP <code>POST</code> method.
   * @param request servlet request
   * @param response servlet response
   * @throws ServletException if a servlet-specific error occurs
   * @throws IOException if an I/O error occurs
   */
  @Override
  protected void doPost(HttpServletRequest request, HttpServletResponse response)
          throws ServletException, IOException {
    processRequest(request, response);
  }

  /**
   * Returns a short description of the servlet.
   * @return a String containing servlet description
   */
  @Override
  public String getServletInfo() {
    return "Short description";
  }// </editor-fold>
}
