/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.plc.graphic.servlets.admin;

import java.io.IOException;
import java.net.URLEncoder;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import uk.plc.graphic.classes.Page;
import uk.plc.graphic.classes.TextBlock;

/**
 *
 * @author Max
 */
public class EditPageBlocks extends HttpServlet {

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String error = null;
        String page_identifier = request.getParameter("page_id");
        String page_title = request.getParameter("title");
        try {
            Page page = Page.getPageByIdentifier(Integer.parseInt(page_identifier));
            page.setTitle(page_title);
            page.editPage();
            HashMap<String, TextBlock> textblocks = page.getTextBlocks();
            String content;
            TextBlock block;
            for (String key : textblocks.keySet()) {
                content = request.getParameter("textarea_" + key);
                block = textblocks.get(key);
                block.setText(content);
                block.editTextBlock();
            }
        } catch (SQLException ex) {
            error = "SQL Exception: '" + ex.getMessage() + "'";
        } catch (NumberFormatException ex) {
            error = "Page id given is not a valid number";
        }
        response.sendRedirect("/admin/edit-page.jsp?p=" + page_identifier +
                (error != null ? "&err=" + URLEncoder.encode(error, "UTF-8") : ""));
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
