/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.plc.graphic.servlets.admin;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileItemFactory;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import uk.plc.graphic.classes.UploadedFile;

/**
 *
 * @author Max
 */
public class UploadFile extends HttpServlet {
    private String fileid;
    private byte[] data;
    private String contentType;
    private String filename;
    private long filesize;
    private Matcher filenameMatcher;
    private static Pattern filenamePattern = Pattern.compile("^.*/([^/][^/]*)$");
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String uri = "";
        int result = 0;
        String error = "";
        boolean isMultipart = ServletFileUpload.isMultipartContent(request);
        if (isMultipart) {
            try {

                // Create a factory for disk-based file items
                FileItemFactory factory = new DiskFileItemFactory();

                // Create a new file upload handler
                ServletFileUpload upload = new ServletFileUpload(factory);

                // Parse the request
                List<FileItem> items = upload.parseRequest(request);
                Iterator<FileItem> iter = items.iterator();
                while (iter.hasNext()) {
                    FileItem item =  iter.next();

                    if (item.isFormField()) {
                        processFormField(item);
                    } else {
                        processUploadedFile(item);
                    }
                }
                if(filename!=null&&fileid!=null&&data!=null){
                    filename = filename.replace("\\", "/");
                    if(filename.contains("/")){
                        filenameMatcher = filenamePattern.matcher(filename);
                        if(filenameMatcher.find()&&filenameMatcher.groupCount()>0){
                            filename = filenameMatcher.group(1);
                        }
                    }
                    if(UploadedFile.uriExists("/"+filename)){
                        error = "File already exists in root with that name";
                    }else{
                        UploadedFile file = UploadedFile.insertFile("/"+filename, filename, contentType, filesize, data);
                        if(file!=null)result = 1;
                    }
                }
            } catch (FileUploadException fileUploadException) {
                error = fileUploadException.getMessage();
            }catch (IOException ioException) {
                error = ioException.getMessage();
            }catch (SQLException sqlException) {
                error = sqlException.getMessage();
            }
        }
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            out.println("<html>");
            out.println("<head>");
            out.println("<script language=\"javascript\" type=\"text/javascript\">");
            out.println("window.top.window.stopUpload(\"" + fileid + "\", " + result + ", \"" + uri + "\", \""+error+"\");");
            out.println("</script>");
            out.println("</head>");
            out.println("<body></body>");
            out.println("</html>");
        } finally {
            out.close();
        }

    }
    private void processFormField(FileItem item){
        if (item.isFormField()) {
            String name = item.getFieldName();
            String value = item.getString();
            if(name.equals("fileid")){
                this.fileid = value;
            }
//            else if(name.equals("folder")){
//                this.folder = value;
//            }
        }
    }
    private void processUploadedFile(FileItem item) throws IOException{
        String fieldName = item.getFieldName();
        this.filename = item.getName();
        this.contentType = item.getContentType();
        this.filesize = item.getSize();
        InputStream stream = item.getInputStream();
        this.data = UploadedFile.getBytes(stream);
    }
    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">

    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
